## net.sf.saxon.style
Class StylesheetFunctionLibrary

    java.lang.Object
      net.sf.saxon.style.StylesheetFunctionLibrary

All Implemented Interfaces:
  java.io.Serializable, FunctionLibrary

    public class StylesheetFunctionLibrary

extends java.lang.Object
implements FunctionLibrary

A StylesheetFunctionLibrary contains functions defined by the user in a stylesheet. This library is used at compile time only, as it contains references to the actual XSLFunction objects. Binding to a function in this library registers the function call on a fix-up list to be notified when the actual compiled function becomes available.

See Also:
  Serialized Form

Constructor Summary
`StylesheetFunctionLibrary(XSLStylesheet sheet, boolean overriding)` Create a FunctionLibrary that provides access to stylesheet functions

Method Summary
`Expression` `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env)` Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`java.util.List` `getAllFunctions()` Get a list of all functions in this StylesheetFunctionLibrary
`boolean` `isAvailable(StructuredQName functionName, int arity)` Test whether a Saxon function with a given name and arity is available.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StylesheetFunctionLibrary

    public StylesheetFunctionLibrary(XSLStylesheet sheet,
                                     boolean overriding)

  Create a FunctionLibrary that provides access to stylesheet functions

  Parameters:
    `sheet` - The XSLStylesheet element of the principal stylesheet module
    `overriding` - set to true if this library is to contain functions specifying override="yes", or to false if it is to contain functions specifying override="no". (XSLT uses two instances of this class, one for overriding functions and one for non-overriding functions.)

Method Detail

### isAvailable

    public boolean isAvailable(StructuredQName functionName,
                               int arity)

  Test whether a Saxon function with a given name and arity is available. This supports the function-available() function in XSLT.

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `functionName` -
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some
  Returns:
    true if a function of this name and arity is available for calling.

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env)
                    throws XPathException

  Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` -
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
    `env` -
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function; or if this function library "owns" the namespace containing the function call, but no function was found.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

### getAllFunctions

    public java.util.List getAllFunctions()

  Get a list of all functions in this StylesheetFunctionLibrary

Copyright (c) Saxonica Limited. All rights reserved.